--
-- Rubbish by Ludovicus (LuisOrtiz@Verizon.NET)
--
-- Initialization Functions
--
-- This addon is dedidicated to Harry Wasylyk & Larry Hansen, the Canadian inventors of the disposable green polyethylene garbage bag.


Rubbish = {
	events = {},
	eventFrame = CreateFrame("Frame")
}


Rubbish.DebugMode = true


function Rubbish:Message(...)
	msg = nil
	for n=1,select('#',...) do
		local item = select(n,...)
		if msg == nil then
			msg = tostring(item)
		else
			msg = msg .. " " .. tostring(item)
		end
	end
	return msg
end


function Rubbish:dprint(...)
	if Rubbish.DebugMode then
		msg = Rubbish:Message("|cffffff00Rubbish|r: ",...)
		print(msg)
	end
end


function Rubbish:dwarn(...)
	if Rubbish.DebugMode then
		msg = Rubbish:Message("|cffff0000Rubbish|r: ",...)
		print(msg)
	end
end


function Rubbish:say(...)
		msg = Rubbish:Message("|cff00ff00Rubbish|r: ",...)
		print(msg)
end


function Rubbish:RegisterEvent(event, method)
	self.eventFrame:RegisterEvent(event)
	self.events[event] = method or event
end


function Rubbish:UnregisterEvent(event)
	self.eventFrame:UnregisterEvent(event)
	self.events[event] = method or event
end


Rubbish.eventFrame:SetScript("OnEvent", function(self, event, ...)
	local method = Rubbish.events[event]
	if method and Rubbish[method] then
		Rubbish[method](Rubbish, event, ...)
	end
end)


-- Sequence of events during startup
--		ADDON_LOADED			Fired once each addon is loaded
--		Wow starts loading variables, macros, keybindings after all addons are loaded
--		SPELLS_CHANGED			Players spells loaded and ready to use
--		PLAYER_LOGIN			World Initialized, UI Positioning done
--		PLAYER_ENTERING_WORLD	
--		VARIABLES_LOADED		All Blizzard variables, macros, keybindings loaded.


function Rubbish:VARIABLES_LOADED(event)
		self:UnregisterEvent("VARIABLES_LOADED")
		Rubbish:Merchant_Init()
		Rubbish:Field_Init()
		Rubbish:Quest_Init()
end


function Rubbish:ADDON_LOADED(event, addon)
	if addon == "Rubbish" then
		self:UnregisterEvent("ADDON_LOADED")
		RubbishDB = RubbishDB or {}
		Rubbish:RegisterEvent("VARIABLES_LOADED")
		if RubbishDB["AlwaysSellJunk"] == nil then
			RubbishDB["AlwaysSellJunk"] = true
		end
	end
end
Rubbish:RegisterEvent("ADDON_LOADED")




